/***
 * 
 * Felipe Brahm
 * Ayudante de Ctedra
 * Introduccin a la Programacin - IIC1102 Seccin 4
 * Pontificia Universidad Catlica de Chile
 *
 * lebrahm <at> uc <punto> cl
 * ICQ#50566818
 *
 * (CC)2006
 * 
 * */

import java.io.*;
import iic1102Package.*;

public class SimulacionMetro {
	
	static Estacion[] estacion = new Estacion[10];
	static Tren[] trenes = new Tren[50];
	static int totalTrenes = 0;

	public static void main(String[] args) throws IOException {

		int minutosTotal;
		do {
			minutosTotal = Interfaz.PedirEntero("Durante cuntos minutos desea simular?");
		} while(minutosTotal < 0);
		
		Interfaz.MostrarMensajeConsola("Iniciando Simulacin");
		
		for(int min = 0; min < minutosTotal; ++min) {
			
			if(min == 0)
				crearEstaciones();
			else if((min/60) == 13 && (min%60) == 0)
				actualizarEstaciones();
			
			/* CREAR TRENES */
			if(min%5 == 0)
				crearTrenes();
			
			/* PASAJEROS ESTACIONES */
			for(int i = 0; i < 10; ++i) {
				
				estacion[i].setPasajerosIda(estacion[i].getPasajerosIda() + estacion[i].getPpmIda());
				estacion[i].setPasajerosVuelta(estacion[i].getPasajerosIda() + estacion[i].getPpmIda());
				
			}
			
			/* TRENES */
			for(int i = 0; i < totalTrenes; ++i) {
				
				Tren tren = trenes[i];
				Estacion est = estacion[tren.getEstacion()];
				
				if(!tren.estaEnCochera()) {
					
					if(tren.tiempoProxEst() == 0) {
						
						if(tren.getDireccion() == 1) {
							
							int bajar;
							
							bajar = calcularPasajerosProb(tren.getPasajeros(), est.getProbTrasbordoIda());
							tren.bajarPasajeros(bajar);
							bajar = calcularPasajerosProb(tren.getPasajeros(), est.getProbBajadaIda());
							tren.bajarPasajeros(bajar);
							
							//se suben todos los que estn esperando.. hasta el tope de la capacidad
							int subir;

							if(est.getPasajerosIda() <= tren.getCapacidad() - tren.getPasajeros())
								subir = est.getPasajerosIda();
							else
								subir = est.getPasajerosIda() - (tren.getCapacidad() - tren.getPasajeros());

							tren.subirPasajeros(subir);
							
							est.setPasajerosIda(est.getPasajerosIda() - subir);
							
						} else {

							int bajar;
							
							bajar = calcularPasajerosProb(tren.getPasajeros(), est.getProbTrasbordoVuelta());
							tren.bajarPasajeros(bajar);
							bajar = calcularPasajerosProb(tren.getPasajeros(), est.getProbBajadaVuelta());
							tren.bajarPasajeros(bajar);
							
							//se suben todos los que estn esperando.. hasta el tope de la capacVueltad
							int subir;

							if(est.getPasajerosVuelta() <= tren.getCapacidad() - tren.getPasajeros())
								subir = est.getPasajerosVuelta();
							else
								subir = est.getPasajerosVuelta() - (tren.getCapacidad() - tren.getPasajeros());

							tren.subirPasajeros(subir);
							
							est.setPasajerosVuelta(est.getPasajerosVuelta() - subir);
							
						}
						
					}
					
				}
				
				tren.avanzar();
				
			}
			
		}

	}
	
	private static void crearTrenes() {
		
		//buscar si hay un tren creado, en cochera
		int desocupado1 = -1;
		int desocupado2 = -1;
		for(int i = 0; i < totalTrenes; ++i) {
			
			if(trenes[i].estaEnCochera()) {
				if(desocupado1 != -1)
					desocupado1 = i;
				else {
					desocupado2 = i;
					break; //salir del for
				}
			}
		}
		
		if(desocupado1 != -1) {
			trenes[desocupado1].setNew(1, 0);
		} else {
			trenes[totalTrenes++] = new Tren(200, 1, 4, 0);
		}
		
		if(desocupado2 != -1) {
			trenes[desocupado2].setNew(1, 0);
		} else {
			trenes[totalTrenes++] = new Tren(200, -1, 4, 9);
		}
		
	}

	private static void actualizarEstaciones() throws IOException {

		FileReader lector = new FileReader("tarde.txt");
		BufferedReader buffer = new BufferedReader(lector);
		
		String linea;

		int total = 0;
		
		linea = buffer.readLine();
		while(linea != null && total < 10) {
			
			int desde, hasta;
			
			desde = 0; hasta = linea.indexOf('\t');
			int ppmIda = Integer.parseInt(linea.substring(desde, hasta));
			desde = hasta+1;
			//indexOf(int ch, int fromIndex);
			hasta = linea.indexOf('\t', desde);
			int ppmVuelta = Integer.parseInt(linea.substring(desde, hasta));
			desde = hasta+1;
			hasta = linea.indexOf('\t', desde);
			float probBajadaIda = Float.parseFloat(linea.substring(desde, hasta));
			desde = hasta+1;
			hasta = linea.indexOf('\t', desde);
			float probBajadaVuelta = Float.parseFloat(linea.substring(desde, hasta));
			desde = hasta+1;
			hasta = linea.indexOf('\t', desde);
			float probTrasbordoIda = Float.parseFloat(linea.substring(desde, hasta));
			desde = hasta+1;
			float probTrasbordoVuelta = Float.parseFloat(linea.substring(desde, hasta));
			
			estacion[total].setPpmIda(ppmIda);
			estacion[total].setPpmVuelta(ppmVuelta);
			estacion[total].setProbBajadaIda(probBajadaIda);
			estacion[total].setProbBajadaVuelta(probBajadaVuelta);
			estacion[total].setProbTrasbordoIda(probTrasbordoIda);
			estacion[total].setProbTrasbordoVuelta(probTrasbordoVuelta);

			++total;
			linea = buffer.readLine();
		}
		
		lector.close();
		buffer.close();
		
	}

	private static void crearEstaciones() throws IOException {

		FileReader lector = new FileReader("manana.txt");
		BufferedReader buffer = new BufferedReader(lector);
		
		String linea;

		int total = 0;
		
		linea = buffer.readLine();
		while(linea != null && total < 10) {
			
			int desde, hasta;
			
			desde = 0; hasta = linea.indexOf('\t');
			int ppmIda = Integer.parseInt(linea.substring(desde, hasta));
			desde = hasta+1;
			//indexOf(int ch, int fromIndex);
			hasta = linea.indexOf('\t', desde);
			int ppmVuelta = Integer.parseInt(linea.substring(desde, hasta));
			desde = hasta+1;
			hasta = linea.indexOf('\t', desde);
			float probBajadaIda = Float.parseFloat(linea.substring(desde, hasta));
			desde = hasta+1;
			hasta = linea.indexOf('\t', desde);
			float probBajadaVuelta = Float.parseFloat(linea.substring(desde, hasta));
			desde = hasta+1;
			hasta = linea.indexOf('\t', desde);
			float probTrasbordoIda = Float.parseFloat(linea.substring(desde, hasta));
			desde = hasta+1;
			float probTrasbordoVuelta = Float.parseFloat(linea.substring(desde));
			
			estacion[total] = new Estacion(ppmIda, ppmVuelta, probBajadaIda, probBajadaVuelta, probTrasbordoIda, probTrasbordoVuelta);
			++total;
			linea = buffer.readLine();
		}
		
		lector.close();
		buffer.close();
		
	}

	public static int calcularPasajerosProb(int total, float prob) {
		
		int r = 0;
		for(int i = 0; i < total; ++i) {
			if(Tools.randomAB(0,100) <= (int)prob*100)
				++r;
		}
		return r;
		
	}

}
